varying vec3 normal;
varying vec4 viewPos;

void main(void){
	// get vector to light position
	vec4 lightVec = normalize(gl_LightSource[0].position - viewPos);
	vec4 camVec = normalize(viewPos);

	vec3 normalized = normalize(normal);

	float ndotl = max(dot(lightVec.xyz, normalized),0.0);

	// diffuse
	vec4 diffuse = ndotl * gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	
	// phong
	vec4 specular;
	vec3 H = normalize(lightVec - camVec);
	float ndoth = dot(normalized,H);
	if ( ndoth > 0.0 ){
		float spec = pow(ndoth, gl_FrontMaterial.shininess);
		specular = spec * gl_FrontMaterial.specular * gl_LightSource[0].specular;
	}
	else{
		specular = (0.0,0.0,0.0,0.0);
	}

	// ambient
	vec4 ambient = gl_FrontMaterial.ambient * (gl_LightSource[0].ambient + gl_LightModel.ambient);

	gl_FragColor = ambient + diffuse + specular + gl_FrontMaterial.emission;
}
